local N, T = ...

-- https://wow.gamepedia.com/AddOn_loading_process
T.Register_Event(
    "PLAYER_LOGIN",
    function()
        local components = {
            -- {用户模式是否加载, 初始函数}
            ui = {true, "Setup_UI"},
            automation = {true, "Setup_Automation"},
            hud = {true, "Setup_HUD"},
            shortcut = {true, "Setup_Shortcut"},
            item = {true, "Setup_Item"},
            spamblocker = {true, "Setup_SpamBlocker"},
            macro = {false, "Setup_Macro"},
            friendlist = {false, "Setup_Friendlist"},
            combatlog = {false, "Setup_Combatlog"},
            debug = {false, "Setup_Debug"}
        }
        T.IsAuthor = T.IsAuthor or force_author
        disabled_components = disabled_components or {}
        for k, v in pairs(components) do
            if (T.IsAuthor or v[1]) and (not disabled_components[k]) then
                T.PCall(T[v[2]])
            end
        end
        local function print_component_state()
            print(" ")
            print("Components:")
            for k, v in pairs(components) do
                if T.IsAuthor or v[1] then
                    local enabled = disabled_components[k] and T.Red("OFF") or T.Green("ON")
                    print(k, enabled)
                end
            end
        end
        T.Add_Slash_Command(
            {
                name = "MY_PREFERENCE_CONFIG",
                commands = {"/mypref"},
                callback = function(...)
                    local args = {...}
                    if args[1] == "enable" or args[1] == "disable" then
                        local enable = args[1] == "enable"
                        if args[2] == "author" then
                            force_author = enable
                        elseif args[2] == "all" then
                            for k, v in pairs(components) do
                                disabled_components[k] = not enable
                            end
                            print_component_state()
                        elseif components[args[2]] then
                            disabled_components[args[2]] = not enable
                            print_component_state()
                        end
                    else
                        print_component_state()
                    end
                end
            }
        )
        -- 打印插件状态
        T.Add_Slash_Command(
            {
                name = "PRINT_ADDON_STATES",
                commands = {"/pas"},
                callback = function(...)
                    UpdateAddOnMemoryUsage()
                    local states = {}
                    local max_name_len = 0
                    for i = 1, GetNumAddOns() do
                        if IsAddOnLoaded(i) then
                            local name = ({GetAddOnInfo(i)})[1]
                            max_name_len = #name > max_name_len and #name or max_name_len
                            table.insert(states, {name, GetAddOnMemoryUsage(i)})
                        end
                    end
                    table.sort(
                        states,
                        function(a, b)
                            return a[2] > b[2]
                        end
                    )
                    print(" ")
                    print("Memory usage of currently loaded plugins:")
                    for i, v in ipairs(states) do
                        print(string.format("%-" .. max_name_len .. "s %.2f KB", v[1], v[2]))
                    end
                end
            }
        )

        -- for _, fname in ipairs(
        --     {
        --         "Setup_UI",
        --         "Setup_Automation",
        --         "Setup_HUD",
        --         "Setup_Shortcut",
        --         "Setup_Item"
        --     }
        -- ) do
        --     T.PCall(T[fname])
        -- end
        -- if T.IsAuthor then
        --     for _, fname in ipairs(
        --         {
        --             "Setup_Macro",
        --             "Setup_Friendlist",
        --             "Setup_Combatlog",
        --             "Setup_Debug"
        --         }
        --     ) do
        --         T.PCall(T[fname])
        --     end
        -- end
    end
)
