local N, T = ...

function T.Setup_Macro()
    local function get_player()
        local player = {
            race = ({UnitRace("player")})[2],
            class = ({UnitClass("player")})[2],
            faction = ({UnitFactionGroup("player")})[1],
            level = UnitLevel("player"),
            specialization = GetSpecialization() -- 新创建没有设置专精的返回5
        }
        player.racial_active_abilitiy =
            ({
            -- 联盟
            Human = "生存意志(种族特长)",
            Dwarf = "石像形态(种族特长)",
            NightElf = "影遁(种族特长)",
            Gnome = "逃命专家(种族特长)",
            Draenei = "纳鲁的赐福(种族特长)",
            Worgen = "疾步夜行(种族特长)",
            VoidElf = "空间裂隙(种族特长)",
            LightforgedDraenei = "圣光裁决者(种族特长)",
            DarkIronDwarf = "烈焰之血(种族特长)",
            KulTiran = "强力一击(种族特长)",
            Mechagnome = "超有机光影发生器(种族特长)",
            -- 部落
            Orc = "血性狂怒(种族特长)",
            Scourge = "被遗忘者的意志(种族特长)",
            Tauren = "战争践踏(种族特长)",
            Troll = "狂暴(种族特长)",
            BloodElf = "奥术洪流(种族特长)",
            Goblin = "火箭跳(种族特长)",
            Nightborne = "奥术脉冲(种族特长)",
            HighmountainTauren = "蛮牛冲撞(种族特长)",
            MagharOrc = "先祖召唤(种族特长)",
            ZandalariTroll = "再生！(种族特长)",
            Vulpera = "袋里乾坤(种族特长)",
            -- 中立
            Pandaren = "震山掌(种族特长)"
        })[player.race] or "复活战斗宠物"
        player.dash_or_mount =
            (player.level < 10 and player.class ~= "DEATHKNIGHT") and {"summonmount", "召唤司机"} or {"macro", "跑"}
        return player
    end

    local function setup_macro(player)
        local global_macros = {
            -- ["躺下"] = "/lie\n",
            ["扔"] = "#showtooltip\n/cancelaura 神圣惩戒\n/use 画着芜菁的“枪”\n/use 水果篮\n/use 裂心者\n/use 达拉然飞碟\n/use 足球\n",
            ["足球"] = "#showtooltip\n/cancelaura 神圣惩戒\n/use 足球\n/sit\n",
            ["手球"] = "#showtooltip\n/cancelaura 神圣惩戒\n/use 橄榄球\n/sit\n",
            ["玩具"] = "/use 上层精灵的灵魂镜\n/use 个人全息投影仪\n/use 大法师瓦格斯的备用法杖\n/use 山丘之王的圣杯\n/use 怨恨尖塔\n/use 星图\n/use 松软的绿色沙发垫\n/use 炉石游戏盘\n/use 烈焰舞娘火盆\n/use 神奇的啤酒桶\n/use 莉莉安的警告牌\n/use 永恒沙漏\n/use 堆叠式雄鹿\n/use 寄魂战鼓\n/use 旧娃娃\n/use 浪漫午餐篮\n/use 燃烧军团便携传送门\n/use 虚空图腾\n/use 记忆之盒\n/use 集结战旗\n",
            -- ["邀会"] = "/ginvite\n",
            ["堆栈"] = "/fstack\n",
            -- ["强e"] = "/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            -- ["强p"] = "/use [combat] 联盟军旗\n/use [combat] 部落军旗\n/use [combat] 护火者之誓\n",
            ["披风"] = "#showtooltip\n/dismount [flying]\n/cancelform [flying]\n/use 15\n/use 远程拾取器\n/use 芬德尔的远程拾取器\n/cast 拾回\n",
            ["腰带"] = "#showtooltip\n/use 6\n",
            ["EAB"] = "/click ExtraActionButton1\n",
            ["节日"] = "#showtooltip\n/cast 钓鱼\n/use 先祖硬币\n/use 红包\n/use 一把糖果\n/use 封印的暗月箱子\n",
            ["日常"] = "/tar 偷懒的龙喉苦工\n/use 训诫靴\n/use 亚兹尔的羊肉\n/use 天空卫队的炸弹\n/use 冠军的钱包\n/use 震地者之鼓\n/use 烈焰之矛\n/use 缴获的克瓦迪尔旗帜\n/use 疣无忧唇膏\n/kiss\n/use 加重的扣网\n/use 唤雾者的符咒\n/use 克瓦迪尔战争号角\n/use 光明祝福圣物\n/use 忏悔者的祈祷书\n/use 新鲜的鱼饵\n/use 狼的尖牙\n/use 魔法药膏\n/use 磁性废料收集器\n/use 戳鸟之矛\n",
            ["离开"] = "/sit\n/afk\n",
            -- ["挥动"] = "/use [@player] 怒根之种\n/use 神圣香炉\n",
            ["观察"] = '/script InspectUnit("target")\n',
            ["Cry"] = '/run if cr then cr:Cancel()cr=nil print("Cry OFF") else DoEmote("kneel")cr=C_Timer.NewTicker(6,function()DoEmote("cry")end)print("Cry ON")end\n',
            ["Dance"] = '/run if da then da:Cancel()da=nil print("Dance OFF") else da=C_Timer.NewTicker(11,function()DoEmote("stand")C_Timer.After(math.random(4,6)/10, function()DoEmote("dance")end)end)print("Dance ON")end\n',
            ["Chicken"] = '/run if ch then ch:Cancel()ch=nil print("Chicken OFF") else ch=C_Timer.NewTicker(7,function()DoEmote("chicken")end)print("Chicken ON")end\n',
            ["Laugh"] = '/run if la then la:Cancel()la=nil print("Laugh OFF") else la=C_Timer.NewTicker(8,function()DoEmote("laugh")end)print("Laugh ON")end\n',
            ["Mountspecial"] = '/run if mo then mo:Cancel()mo=nil print("Mountspecial OFF") else mo=C_Timer.NewTicker(60,function()DoEmote("mountspecial")end)print("Mountspecial ON")end\n',
            ["Turkey"] = '/run if tu then tu:Cancel()tu=nil print("Turkey OFF") else tu=C_Timer.NewTicker(27,function()local id="BattlePet-0-0000066A198E" if C_PetJournal.GetSummonedPetGUID()~=id then C_PetJournal.SummonPetByGUID(id)end end)print("Turkey ON")end\n',
            ["Follow"] = '/run if fo then fo:Cancel()fo=nil print("Follow OFF") else fo=C_Timer.NewTicker(3,function()FollowUnit("focus")end)print("Follow ON")end\n',
            -- ["MAX"] = '/run print("/* MAX开头的全局变量 */")for k, v in pairs(_G) do if k:find("^MAX_") then print(k.."=", v)end end\n',
            -- ["MIN"] = '/run print("/* MIN开头的全局变量 */")for k, v in pairs(_G) do if k:find("^MIN_") then print(k.."=", v)end end\n',
            -- ["猎手阿图门"] = "/tar 猎手阿图门\n",
            -- ["黑心"] = "/tar 布尔吉·黑心\n/cast 英勇投掷\n",
            ["旗"] = "#showtooltip\n/use 协同战旗\n/use 神秘水果帽\n/use 世界缩小器\n/use 巨怒射线枪\n/lie\n/afk\n",
            -- ["CD"] = "/w 恩托哇-瓦里安 9\n/w 太阳断月之弦-末日行者 9\n/w 咩咩的羊羔-金色平原 9\n/w 咩咩的羊羔-瓦里安 9\n/w 愤怒的羊羊-瓦拉纳 9\n/w 咩咩的猎手-金色平原 9\n/w 愤怒的羊羊-冰霜之刃 9\n",
            -- ["CCA"] = covenant_ability_macro(player.class),
            -- ["CSA"] = covenant_ability_macro("Signature")
            ["骨尘"] = "#showtooltip\n/cast [@player] 骨尘酒\n",
            ["影遁"] = "#showtooltip\n/use [combat] 家传的联盟徽记\n/use [combat] 纯净的第三月碎片\n/cast [combat,nostealth] !影遁;!潜行\n",
            ["箱子"] = "#showtooltip\n/use 勇士的采矿箱\n/use 勇士的剥皮箱\n/use 勇士的裁缝箱\n/use 勇士的附魔箱\n/use 冒险者的采矿箱\n/use 冒险者的剥皮箱\n/use 冒险者的裁缝箱\n/use 冒险者的附魔箱\n",
        }
        if InCombatLockdown() then
            return
        end
        local gn, pcn = GetNumMacros()
        -- 通用宏
        for i = gn, 1, -1 do
            local n = ({GetMacroInfo(i)})[1]
            if not global_macros[n] then
                print("DeleteMacro", n)
                DeleteMacro(i)
            end
        end
        for n, b in pairs(global_macros) do
            local i = GetMacroIndexByName(n)
            if i == 0 or i > 120 then
                print("CreateMacro", n)
                CreateMacro(n, "INV_Misc_QuestionMark", b, nil, 1)
            elseif GetMacroBody(i) ~= b then
                print("EditMacro", n)
                EditMacro(i, nil, nil, b)
            end
        end
        -- 角色专用宏
        if not T.Class_Macro[player.class] then
            return
        end
        local per_char_macros = T.Class_Macro[player.class](player)
        if not per_char_macros then
            return
        end
        for i = pcn + 120, 121, -1 do
            if not per_char_macros[({GetMacroInfo(i)})[1]] then
                DeleteMacro(i)
            end
        end
        for n, b in pairs(per_char_macros) do
            local i = GetMacroIndexByName(n)
            if i == 0 or i < 121 then
                print("CreateMacro", n)
                CreateMacro(n, "INV_Misc_QuestionMark", b, 1, 1)
            elseif GetMacroBody(i) ~= b then
                print("EditMacro", n)
                EditMacro(i, nil, nil, b)
            end
        end
    end

    local function clear_slot(slot)
        ClearCursor()
        PickupAction(slot)
        return slot + 1
    end

    local function place_macro(name, slot, warning)
        ClearCursor()
        if GetMacroInfo(name) then
            PickupMacro(name) -- PickupMacro名字id皆可
            PlaceAction(slot)
            return slot + 1
        else
            if warning then
                print('找不到宏"' .. name .. '"')
            end
            return slot
        end
    end

    local function place_spell(name, slot, warning)
        ClearCursor()
        local n, _, _, _, _, _, id = GetSpellInfo(name)
        if n then
            PickupSpell(id) -- PickupSpell只接受id，经测试，也作用于坐骑
            PlaceAction(slot)
            return slot + 1
        else
            if warning then
                print('找不到法术"' .. name .. '"')
            end
            return slot
        end
    end

    local function place_item(name, slot, warning)
        ClearCursor()
        local id = GetItemInfoInstant(name)
        if id then
            PickupItem(id) -- 经测试PickupItem也只接受id
            PlaceAction(slot)
            return slot + 1
        else
            if warning then
                print('找不到物品"' .. name .. '"')
            end
            return slot
        end
    end

    local function place_pet(name, slot, warning)
        ClearCursor()
        local _, id = C_PetJournal.FindPetIDByName(name)
        if id then
            C_PetJournal.PickupPet(id)
            PlaceAction(slot)
            return slot + 1
        else
            if warning then
                print('找不到宠物"' .. name .. '"')
            end
            return slot
        end
    end

    local function place_flyout(name, slot, warning)
        -- Flyout弹出式法术按钮只能通过PickupSpellBookItem从法术书中拾取，https://us.battle.net/forums/en/wow/topic/3229376525
        ClearCursor()
        local index_found = nil
        for tab = 1, GetNumSpellTabs() do
            local tab_name, tab_texture, tab_offset, num_entries = GetSpellTabInfo(tab)
            for index = tab_offset + 1, tab_offset + num_entries do
                local skill_type, special = GetSpellBookItemInfo(index, BOOKTYPE_SPELL)
                if skill_type and skill_type == "FLYOUT" then
                    local spell_name, spell_subname = GetSpellBookItemName(index, BOOKTYPE_SPELL)
                    if spell_name == name then
                        index_found = index
                        break
                    end
                end
            end
            if index_found then
                break
            end
        end
        if index_found then
            PickupSpellBookItem(index_found, BOOKTYPE_SPELL)
            PlaceAction(slot)
            return slot + 1
        else
            if warning then
                print('找不到弹出式按钮"' .. name .. '"')
            end
            return slot
        end
    end

    local function setup_bar(player)
        -- 显示主动作条、左下动作条和右侧两动作条
        local bl, br, r1, r2 = GetActionBarToggles()
        SetActionBarToggles(1, br, 1, 1)
        SHOW_MULTI_ACTIONBAR_1 = 1
        SHOW_MULTI_ACTIONBAR_3 = 1
        SHOW_MULTI_ACTIONBAR_4 = 1
        MultiActionBar_Update()
        -- 主动作条，左下动作条
        if not T.Class_Bar[player.class] then
            return
        end
        local class_bars = T.Class_Bar[player.class](player)
        if class_bars and class_bars[player.specialization] then
            for slot, action in pairs(class_bars[player.specialization]) do
                if not action then
                    -- 什么都不做
                elseif not action[1] then
                    clear_slot(slot)
                elseif action[1] == "macro" then
                    place_macro(action[2], slot, true)
                elseif action[1] == "spell" then
                    place_spell(action[2], slot, true)
                elseif action[1] == "item" then
                    place_item(action[2], slot, true)
                elseif action[1] == "summonmount" then
                    place_spell(action[2], slot, true)
                elseif action[1] == "summonpet" then
                    place_pet(action[2], slot, true)
                elseif action[1] == "flyout" then
                    place_flyout(action[2], slot, true)
                end
            end
        end
        -- 右侧两动作条
        CollectionsJournal_LoadUI() -- 玩具箱是插件形式存在的
        local slot = 25
        -- 常用坐骑
        slot = place_spell("雄壮远足牦牛", slot)
        -- 传送类
        slot = place_spell("星界传送", slot) -- shaman
        slot = place_item("城镇传送之书", slot)
        -- slot = place_item("飞行管理员的哨子", slot)
        slot = place_spell("传送：月光林地", slot) -- dru
        slot = place_spell("梦境行者", slot)
        slot = place_flyout("传送", slot) -- mage
        slot = place_flyout("传送门", slot)
        slot = place_spell("黑锋之门", slot) -- dk
        slot = place_spell("禅宗朝圣", slot) -- monk
        slot = place_item("达拉然炉石", slot)
        slot = place_item("要塞炉石", slot)
        slot = place_item("海军上将的罗盘", slot)
        slot = place_spell("钻探机(种族特长)", slot) -- 黑铁矮人
        slot = place_item("烈酒的遥控器", slot)
        -- 专业技能和公会功能
        -- for _, index in ipairs({GetProfessions()}) do
        --     local name = GetProfessionInfo(index)
        --     print(name)
        --     local spell_to_slot =
        --         ({
        --         ["裁缝"] = "裁缝",
        --         ["附魔"] = "附魔",
        --         ["采矿"] = "采矿技能",
        --         ["工程学"] = "工程学",
        --         ["锻造"] = "锻造",
        --         ["珠宝加工"] = "珠宝加工",
        --         ["草药学"] = "草药学技能",
        --         ["炼金术"] = "炼金术",
        --         ["铭文"] = "铭文",
        --         ["剥皮"] = "剥皮技能",
        --         ["制皮"] = "制皮"
        --     })[name]
        --     if spell_to_slot then
        --         print(spell_to_slot)
        --         slot = place_spell(spell_to_slot, slot)
        --     end
        -- end
        slot = place_spell("符文熔铸", slot) -- 类似于附魔
        slot = place_spell("呼叫大胖(种族特长)", slot) -- 地精的银行
        slot = place_spell("移动银行", slot)
        -- 复活和战复
        local respawn_spells =
            ({
            DRUID = {"起死回生", "复生", "新生"},
            DEATHKNIGHT = {"复活盟友"},
            PALADIN = {"救赎", "宽恕"},
            SHAMAN = {"先祖之魂", "先祖视界"}, -- 萨满有个被动也叫“复生”会提示不能放置
            PRIEST = {"复活术", "群体复活"},
            MONK = {"轮回转世", "死而复生"}
        })[player.class]
        if respawn_spells then
            for _, spell in ipairs(respawn_spells) do
                -- print(spell)
                slot = place_spell(spell, slot)
            end
        end
        -- slot = place_spell("复活战斗宠物", slot)
        -- 最后清理一下光标
        ClearCursor()
    end

    local function clear_all_bar()
        for slot = 1, 120 do
            clear_slot(slot)
        end
    end

    local function check_bar()
        for slot = 1, 120 do
            if HasAction(slot) then
                local type, id, stype = GetActionInfo(slot)
                local name = ""
                if type == "spell" then
                    name = GetSpellInfo(id)
                elseif type == "item" then
                    name = GetItemInfo(id)
                elseif type == "macro" then
                    name = GetMacroInfo(id)
                elseif type == "companion" then
                    _, name = GetCompanionInfo(stype, id)
                elseif type == "equipmentset" then
                    name = id
                    id = C_EquipmentSet.GetEquipmentSetID(name)
                elseif type == "summonmount" then
                    name = C_MountJournal.GetMountInfoByID(id)
                elseif type == "summonpet" then
                    _, _, _, _, _, _, _, name = C_PetJournal.GetPetInfoByPetID(id)
                end
                print(slot, type, id, stype, name)
            end
        end
        for tab = 1, GetNumSpellTabs() do
            local tab_name, tab_texture, tab_offset, num_entries = GetSpellTabInfo(tab)
            for index = tab_offset + 1, tab_offset + num_entries do
                local skill_type, special = GetSpellBookItemInfo(index, BOOKTYPE_SPELL)
                if skill_type and skill_type == "FLYOUT" then
                    local spell_name, spell_subname = GetSpellBookItemName(index, BOOKTYPE_SPELL)
                    print(index, tab_name, skill_type, spell_name)
                end
            end
        end
    end

    local function setup_talent(player)
        if not IsResting() then
            return
        end
        local talents = T.Class_Talent[player.class]
        if not talents then
            return
        end
        local talents = talents(player)
        if not talents then
            return
        end
        talents = talents[player.specialization]
        if not talents then
            return
        end
        for tier, column in ipairs(talents) do
            local talent_id, talent_name = GetTalentInfoBySpecialization(player.specialization, tier, column)
            -- print(tier, column, talent_id, talent_name)
            if not LearnTalent(talent_id) then
                print("LearnTalent(" .. talent_name .. ") = false")
            end
        end
    end

    local btn_preset = CreateFrame("Button", nil, SpellBookFrame, "UIPanelButtonTemplate")
    btn_preset:SetText("预设")
    btn_preset:SetSize(btn_preset:GetTextWidth() + 12, btn_preset:GetTextHeight() + 8)
    btn_preset:SetPoint("TOPRIGHT", SpellBookFrame, "TOPRIGHT", -30, 0)
    btn_preset:SetScript(
        "OnClick",
        function()
            local player = get_player()
            setup_talent(player)
            setup_macro(player)
            setup_bar(player)
        end
    )

    local btn_clear_all = CreateFrame("Button", nil, SpellBookFrame, "UIPanelButtonTemplate")
    btn_clear_all:SetText("清空")
    btn_clear_all:SetSize(btn_preset:GetTextWidth() + 12, btn_preset:GetTextHeight() + 8)
    btn_clear_all:SetPoint("TOPRIGHT", btn_preset, "TOPLEFT", 0, 0)
    btn_clear_all:SetScript("OnClick", clear_all_bar)

    local btn_check = CreateFrame("Button", nil, SpellBookFrame, "UIPanelButtonTemplate")
    btn_check:SetText("检查")
    btn_check:SetSize(btn_preset:GetTextWidth() + 12, btn_preset:GetTextHeight() + 8)
    btn_check:SetPoint("TOPRIGHT", btn_clear_all, "TOPLEFT", 0, 0)
    btn_check:SetScript("OnClick", check_bar)
end
