local N, T = ...

T.Class_Macro.PRIEST = function(player)
    return {
        ["跑"] = "#showtooltip\n/cast [spec:3,noform] !暗影形态\n/cast [nocombat,outdoors,@player] 真言术：韧\n/use [nocombat,outdoors] !大祭司的光誓寻觅者\n/cast [combat,spec:2,talent:2/3,@player][indoors,spec:2,talent:2/3,@player] 天堂之羽\n",
        ["羽"] = "#showtooltip\n/cast [@player] 天堂之羽\n",
        ["漂浮"] = "#showtooltip\n/cast [@player] 漂浮术\n",
        ["韧"] = "#showtooltip\n/cast [@player] 真言术：韧\n",
        ["净化"] = "#showtooltip\n/cast [harm] 驱散魔法\n/cast [spec:1/2] 纯净术\n/cast [spec:3] 净化疾病\n",
        ["群驱"] = "#showtooltip\n/cast [@player] 群体驱散\n",
        ["震爆"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 心灵震爆\n",
        ["惩击"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nomod,nochanneling] 惩击\n/cast [mod,nochanneling] 精神灼烧\n", -- 也是心灵鞭笞
        ["罚"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 圣言术：罚\n",
        ["神圣"] = player.level > 20 and
            "#showtooltip\n/castsequence [group] reset=combat,6 快速治疗,治疗术\n/castsequence [nogroup,@player] reset=combat,9 真言术：盾,恢复,愈合祷言,真言术：盾,快速治疗,快速治疗,快速治疗\n" or
            "#showtooltip\n/castsequence reset=target,6 真言术：盾,恢复,快速治疗,治疗术\n",
        ["灵"] = "#showtooltip\n/cast [@player] 圣言术：灵\n",
        ["痛"] = "#showtooltip\n/targetenemy [nomod,noharm][nomod,dead]\n/startattack [nomod]\n/cast [nomod] 暗言术：痛;神圣新星\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n/use [combat] 庆典烟火\n",
        ["新星"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 神圣新星\n",
        ["苦修"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 苦修\n",
        ["戒律"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nochanneling] reset=6 真言术：盾,净化邪恶,苦修,精神灼烧\n"
    }
end

T.Class_Bar.PRIEST = function(player)
    return {
        -- 戒律
        {
            [1] = {"macro", "新星"},
            [2] = {"macro", "痛"},
            [3] = {"macro", "苦修"},
            [4] = nil,
            [5] = player.dash_or_mount,
            [6] = nil,
            [7] = nil,
            [8] = nil,
            [9] = nil,
            [10] = nil,
            [11] = nil,
            [12] = {"macro", "韧"},
            -- 左下动作条
            [61] = {"spell", "真言术：盾"},
            [62] = nil,
            [63] = nil,
            [64] = {"macro", "漂浮"},
            [65] = nil,
            [66] = nil,
            [67] = nil,
            [68] = nil,
            [69] = nil,
            [70] = nil,
            [71] = nil,
            [72] = {"spell", player.racial_active_abilitiy}
        },
        -- 神圣
        {
            [1] = {"macro", "震爆"},
            [2] = {"macro", "痛"},
            [3] = {"macro", "惩击"},
            [4] = {"macro", "罚"},
            [5] = player.dash_or_mount,
            [6] = {"macro", "净化"},
            [7] = {"macro", "羽"},
            [8] = {"macro", "群驱"},
            [9] = nil,
            [10] = {"spell", "绝望祷言"},
            [11] = {"spell", "希望象征"},
            [12] = {"macro", "韧"},
            -- 左下动作条
            [61] = {"macro", "神圣"},
            [62] = {"spell", "圣言术：静"},
            [63] = {"spell", "守护之魂"},
            [64] = {"macro", "漂浮"},
            [65] = {"spell", "治疗之环"},
            [66] = {"spell", "光晕"},
            [67] = {"macro", "灵"},
            [68] = {"spell", "神圣赞美诗"},
            [69] = {"spell", "圣言术：赎"},
            [70] = nil,
            [71] = {"spell", "渐隐术"},
            [72] = {"spell", player.racial_active_abilitiy}
        },
        -- 暗影
        {}
    }
end
