local N, T = ...

T.Class_Macro.SHAMAN = function(player)
    return {
        ["跑"] = "#showtooltip\n/cast [nocombat,outdoors,@player] 水上行走\n/use [nocombat,outdoors] !铁箍鬼灵战马;!幽魂之狼\n",
        ["狼"] = "#showtooltip\n/cast !幽魂之狼\n",
        ["净化"] = "#showtooltip\n/cast [harm] 净化术\n/cast 净化灵魂\n",
        ["恢复"] = (function()
            -- 27级治疗波
            if player.level < 27 then
                return "#showtooltip\n/castsequence reset=6 !激流,治疗之涌,治疗链,治疗之涌\n"
            else
                return "#showtooltip\n/castsequence [talent:6/1] reset=6 !激流,治疗波,治疗链,治疗波,治疗波\n/castsequence [notalent:6/1] reset=6 !激流,治疗波,治疗链,治疗波\n"
            end
        end)(),
        ["灵魂"] = "#showtooltip\n/cast [@player] 灵魂链接图腾\n",
        ["火震"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 烈焰震击\n",
        ["闪电"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [nomod] 闪电箭\n/cast [mod] 闪电链\n/cast [combat] 流星\n/cast [combat] 风暴之眼\n/use [combat] 13\n/use [combat] 14\n/use [combat] 奥拉留斯的低语水晶\n",
        ["电链"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 闪电链\n/cast [combat] 流星\n/cast [combat] 风暴之眼\n/use [combat] 13\n/use [combat] 14\n/use [combat] 奥拉留斯的低语水晶\n",
        ["熔岩"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 熔岩爆裂\n",
        ["冰震"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nomod] 冰霜震击\n/cast [mod] 闪电链\n/cast [combat] 流星\n/cast [combat] 风暴之眼\n/use [combat] 13\n/use [combat] 14\n/use [combat] 奥拉留斯的低语水晶\n",
        ["地震"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [@cursor] 地震术\n",
        ["雷霆"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [@player] 雷霆风暴\n",
        ["电能"] = "#showtooltip\n/cast [@player] 电能图腾\n"
    }
end

T.Class_Bar.SHAMAN = function(player)
    return {
        -- 元素
        {
            [1] = {"macro", "地震"},
            [2] = {"macro", "电链"},
            [3] = {"macro", "闪电"},
            [4] = {"spell", "风剪"},
            [5] = player.dash_or_mount,
            [6] = {"macro", "净化"},
            [7] = {"macro", "狼"},
            [8] = {"spell", "水上行走"},
            [9] = {"spell", "英勇"},
            [10] = {"spell", "嗜血"},
            [11] = nil,
            [12] = nil,
            -- 左下动作条
            [61] = {"spell", "治疗之涌"},
            [62] = {"spell", "治疗之泉图腾"},
            [63] = {"spell", "电能图腾"},
            [65] = {"spell", "星界转移"},
            [66] = {"spell", "土元素"},
            [67] = {"spell", "火元素"},
            [70] = {"spell", "灵魂行者的恩赐"},
            [71] = {"spell", player.faction == "Alliance" and "英勇" or "嗜血"},
            [72] = {"spell", player.racial_active_abilitiy}
        },
        -- 增强
        {},
        -- 恢复
        {
            [1] = {"macro", "熔岩"},
            [2] = {"macro", "电链"},
            [3] = {"macro", "火震"},
            [4] = {"spell", "风剪"},
            [5] = player.dash_or_mount,
            [6] = {"macro", "净化"},
            [7] = {"macro", "狼"},
            [8] = nil,
            [9] = nil,
            [10] = {"spell", "大地之盾"},
            [11] = {"spell", "水之护盾"},
            [12] = {"spell", "水上行走"},
            -- 左下动作条
            [61] = {"macro", "恢复"},
            [62] = {"spell", "治疗之泉图腾"},
            [63] = {"spell", "电能图腾"},
            [64] = nil,
            [65] = {"spell", "星界转移"},
            [66] = {"spell", "土元素"},
            [67] = {"macro", "灵魂"},
            [68] = {"spell", "治疗之潮图腾"},
            [69] = {"spell", "升腾"},
            [70] = {"spell", "灵魂行者的恩赐"},
            [71] = {"spell", player.faction == "Alliance" and "英勇" or "嗜血"},
            [72] = {"spell", player.racial_active_abilitiy}
        }
    }
end
