local N, T = ...

T.Class_Macro.WARRIOR = function(player)
    return {
        ["跑"] = "#showtooltip\n/cast [nocombat,outdoors] 战斗怒吼\n/use [nocombat,outdoors] !铁箍鬼灵战马;英勇飞跃\n",
        ["乘胜"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 乘胜追击\n/cast 冲锋\n/cast 盾牌格挡\n/cast 无视苦痛\n",
        ["冲锋"] = "#showtooltip\n/cast [help] 援护;冲锋\n/cast 断筋\n",
        ["盾猛"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 盾牌猛击\n/cast [mod] 嘲讽\n/cast [combat,group] 盾牌格挡\n/cast [combat,group] 无视苦痛\n/cast [combat] 天神下凡\n/cast [combat] 法术反射\n/use [combat] 13\n/use [combat] 14\n",
        ["雷霆"] = "#showtooltip\n/cast 雷霆一击\n/cast [combat,group] 盾牌格挡\n/cast [combat,group] 无视苦痛\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
        ["复仇"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 复仇\n",
        ["拳击"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 拳击\n/cast 英勇投掷\n",
        ["挫志"] = "#showtooltip\n/castsequence [@player] reset=45 挫志怒吼,巨龙怒吼,破坏者,巨龙怒吼,挫志怒吼,巨龙怒吼,破坏者\n",
        ["斩杀"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 斩杀\n/cast 冲锋\n",
        ["狂怒"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=3 嗜血,旋风斩,盾牌猛击,嗜血,旋风斩,旋风斩\n/cast [combat] 无视苦痛\n/cast [combat] 盾牌格挡\n/cast [combat] 鲁莽\n",
        ["巨人"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [@player] reset=45 灭战者,横扫攻击,破坏者,横扫攻击,灭战者,破坏者,横扫攻击\n",
        ["压制"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=12 压制,致死打击\n",
        ["旋风"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 旋风斩\n/cast [combat] 法术反射\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
    }
end

T.Class_Bar.WARRIOR = function(player)
    return {
        -- 武器
        {
            [1] = {"macro", "巨人"},
            [2] = {"macro", "旋风"},
            [3] = {"macro", "压制"},
            [4] = {"macro", "拳击"},
            [5] = player.dash_or_mount,
            [6] = {"macro", "冲锋"},
            [7] = {"spell", "英勇飞跃"},
            [8] = {"spell", "碎裂投掷"},
            [9] = nil,
            [10] = nil,
            [11] = nil,
            [12] = {"spell", "战斗怒吼"},
            -- 左下动作条
            [61] = {"macro", "乘胜"},
            [62] = {"macro", "斩杀"},
            [63] = {"spell", "断筋"},
            [64] = {"macro", "投掷"},
            [65] = {"spell", "狂暴之怒"},
            [66] = {"spell", "剑在人在"},
            [67] = {"spell", "集结呐喊"},
            [68] = {"spell", "刺耳怒吼"},
            [69] = {"spell", "破胆怒吼"},
            [70] = {"spell", "征服者战旗"},
            [71] = {"spell", "血肉铸造"},
            [72] = {"spell", player.racial_active_abilitiy}
        },
        -- 狂怒
        {
            [1] = {"spell", "剑刃风暴"},
            [2] = {"spell", "旋风斩"},
            [5] = player.dash_or_mount,
            [7] = {"spell", "英勇飞跃"},
            [62] = {"spell", "冲锋"}
        },
        -- 防护
        {
            [1] = {"macro", "雷霆"},
            [2] = {"macro", "盾猛"},
            [3] = {"macro", "复仇"},
            [4] = {"macro", "拳击"},
            [5] = player.dash_or_mount,
            [6] = {"macro", "冲锋"},
            [7] = {"spell", "英勇飞跃"},
            [8] = {"spell", "狂暴之怒"},
            [9] = {"spell", "碎裂投掷"},
            [10] = nil,
            [11] = nil,
            [12] = {"spell", "战斗怒吼"},
            -- 左下动作条
            [61] = {"macro", "乘胜"},
            [62] = {"macro", "斩杀"},
            [63] = {"spell", "震荡波"},
            [64] = {"macro", "投掷"},
            [65] = {"spell", "挫志怒吼"},
            [66] = {"spell", "破釜沉舟"},
            [67] = {"spell", "盾墙"},
            [68] = {"spell", "集结呐喊"},
            [69] = {"spell", "破胆怒吼"},
            [70] = {"spell", "征服者战旗"},
            [71] = {"spell", "血肉铸造"},
            [72] = {"spell", player.racial_active_abilitiy}
        }
    }
end

T.Class_Talent.WARRIOR = function(player)
    return {
        {1, 2, 2, 1, 2, 1, 3},
        {1, 1, 1, 1, 1, 1, 1},
        {3, 1, 1, 2, 3, 1, 1}
    }
end